<template>
  <div
    class="reel"
    :style="{
      '--item-reel-h': height,
      '--item-reel-i-w': itemWidth,
      '--item-reel-i-space': space,
      '--item-reel-bar-thumb-color': _barColors.thumb,
      '--item-reel-bar-track-color': _barColors.track,
    }"
  >
    <slot />
  </div>
</template>

<script>
export default {
  name: 'ItemReel',
  props: {
    height: { type: String, default: 'auto' },
    itemWidth: { type: String, default: 'auto' },
    space: { type: String, default: '0.50rem' },
    barColors: {
      type: Object,
      default: () => ({ thumb: undefined, track: undefined }),
    },
  },
  computed: {
    _barColors() {
      const defaults = {
        thumb: 'var(--g-base-text-color)',
        track: 'var(--g-base-bg-color)',
      };

      return {
        thumb: this.barColors.thumb || defaults.thumb,
        track: this.barColors.track || defaults.track,
      };
    },
  },
};
</script>

<style lang="postcss" scoped>
.reel {
  display: flex;
  height: var(--item-reel-h);
  overflow-x: auto;
  overflow-y: hidden;
  scrollbar-width: none;
}
.reel::-webkit-scrollbar {
  display: none;
}

.reel > * {
  flex: 0 0 var(--item-reel-i-w);
}

.reel > img {
  height: 100%;
  flex-basis: auto;
  width: auto;
}

.reel > * + * {
  margin-left: var(--item-reel-i-space);
}

@screen lg {
  .reel {
    scrollbar-width: auto;
    scrollbar-color: var(--item-reel-bar-thumb-color) theme('colors.orange.100');
  }

  .reel::-webkit-scrollbar {
    display: block;
    height: 0.75rem;
  }

  .reel::-webkit-scrollbar-track {
    background-color: var(--item-reel-bar-track-color);
  }

  .reel::-webkit-scrollbar-thumb {
    background-color: var(--item-reel-bar-thumb-color);
  }
}
</style>
